const path = require('path');

// Field Library
const {
	setGlobalFieldsDirPath,
	setEnablePackageFields,
	setFieldConfigSrc,
	setEnablePackageConfig,
	setFieldLibrarySrc,
	setEnablePackageLibrary
} = require('./fieldsJs');
// Config To Hubl
const { setHublConfigDest, generateHublFromConfig } = require('./build/configToHubl');

module.exports = (data = {}) => {
	data = data || {}
	data = Object.assign({
		enablePackageFields : true,
		enablePackageConfig : true,
		enablePackageLibrary : true,
		globalFieldsDir: null,
		fieldsConfigSrcFile: null,
		fieldsLibrarySrcFile: null,
		configToHublDest: null,
		generateHublConfig: true,
	}, data)

	let {
		globalFieldsDir,
		enablePackageFields,
		fieldsConfigSrcFile,
		enablePackageConfig,
		fieldsLibrarySrcFile,
		enablePackageLibrary,
		configToHublDest,
		generateHublConfig
	} = data

	// Enable
	setEnablePackageFields(!!enablePackageFields);
	setEnablePackageConfig(!!enablePackageConfig);
	setEnablePackageLibrary(!!enablePackageLibrary);

	// Set Global Fields Dir
	if (!!globalFieldsDir) {
		setGlobalFieldsDirPath(path.join(process.env.INIT_CWD, globalFieldsDir))
	}
	// Set Field Config JS Src File
	if (!!fieldsConfigSrcFile) {
		setFieldConfigSrc(path.join(process.env.INIT_CWD, fieldsConfigSrcFile))
	}
	// Set Field Library JS Src File
	if (!!fieldsLibrarySrcFile) {
		setFieldLibrarySrc(path.join(process.env.INIT_CWD, fieldsLibrarySrcFile))
	}
	// Set Config to Hubl destination 
	if (!!configToHublDest) {
		setHublConfigDest(path.join(process.env.INIT_CWD, configToHublDest))
		if (!!generateHublConfig) { 
			generateHublFromConfig();
		}
	}

	return data
};